diff --git a/tests/TestSuite_eeprom_dump.py b/tests/TestSuite_eeprom_dump.py
index ae7d3c89..27fc7103 100644
--- a/tests/TestSuite_eeprom_dump.py
+++ b/tests/TestSuite_eeprom_dump.py
@@ -50,6 +50,7 @@ class TestEepromDump(TestCase):
             "ICE_25G-E810C_SFP",
             "ICE_100G-E810C_QSFP",
             "ICE_25G-E823C_QSFP",
+            "ICE_25G-E810_XXV_SFP",
         ]:
             if testname == "eeprom":
                 count = 1000
diff --git a/tests/TestSuite_generic_flow_api.py b/tests/TestSuite_generic_flow_api.py
index 891652c1..47eb9a66 100644
--- a/tests/TestSuite_generic_flow_api.py
+++ b/tests/TestSuite_generic_flow_api.py
@@ -1089,6 +1089,7 @@ class TestGenericFlowApi(TestCase):
                 "I40E_10G-10G_BASE_T_X722",
                 "I40E_10G-SFP_X722",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E823C_QSFP",
             ],
@@ -1113,6 +1114,7 @@ class TestGenericFlowApi(TestCase):
             "I40E_10G-10G_BASE_T_X722",
             "I40E_10G-SFP_X722",
             "ICE_25G-E810C_SFP",
+            "ICE_25G-E810_XXV_SFP",
             "ICE_100G-E810C_QSFP",
             "ICE_25G-E823C_QSFP",
         ]:
@@ -1190,6 +1192,7 @@ class TestGenericFlowApi(TestCase):
             in [
                 "IXGBE_10G-82599_SFP",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "IGB_1G-82576_QUAD_COPPER_ET2",
                 "IGB_1G-82576_QUAD_COPPER",
@@ -1207,6 +1210,7 @@ class TestGenericFlowApi(TestCase):
                 "IGC-I225_LM",
                 "IGC-I226_LM",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E823C_QSFP",
             ],
@@ -1232,6 +1236,7 @@ class TestGenericFlowApi(TestCase):
             "I40E_10G-SFP_X722",
             "I40E_10G-10G_BASE_T_X722",
             "ICE_25G-E810C_SFP",
+            "ICE_25G-E810_XXV_SFP",
             "ICE_100G-E810C_QSFP",
             "ICE_25G-E823C_QSFP",
         ]:
@@ -1328,6 +1333,7 @@ class TestGenericFlowApi(TestCase):
                 "IGC-I225_LM",
                 "IGC-I226_LM",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E823C_QSFP",
             ],
@@ -1397,6 +1403,7 @@ class TestGenericFlowApi(TestCase):
                 "I40E_25G-25G_SFP28",
                 "I40E_10G-10G_BASE_T_BC",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E823C_QSFP",
             ],
@@ -1530,6 +1537,7 @@ class TestGenericFlowApi(TestCase):
                 "I40E_25G-25G_SFP28",
                 "I40E_10G-10G_BASE_T_BC",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E823C_QSFP",
             ],
@@ -1665,6 +1673,7 @@ class TestGenericFlowApi(TestCase):
                 "I40E_25G-25G_SFP28",
                 "I40E_10G-10G_BASE_T_BC",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E823C_QSFP",
             ],
@@ -1800,6 +1809,7 @@ class TestGenericFlowApi(TestCase):
                 "I40E_25G-25G_SFP28",
                 "I40E_10G-10G_BASE_T_BC",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E823C_QSFP",
             ],
@@ -1945,6 +1955,7 @@ class TestGenericFlowApi(TestCase):
                 "I40E_25G-25G_SFP28",
                 "I40E_10G-10G_BASE_T_BC",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E823C_QSFP",
             ],
@@ -2281,6 +2292,7 @@ class TestGenericFlowApi(TestCase):
                 "IGC-I225_LM",
                 "IGC-I226_LM",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E823C_QSFP",
             ],
@@ -2605,6 +2617,7 @@ class TestGenericFlowApi(TestCase):
             in [
                 "IXGBE_10G-82599_SFP",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E823C_QSFP",
                 "IXGBE_10G-X550EM_X_10G_T",
@@ -2627,6 +2640,7 @@ class TestGenericFlowApi(TestCase):
             "I40E_25G-25G_SFP28",
             "I40E_40G-QSFP_A",
             "ICE_25G-E810C_SFP",
+            "ICE_25G-E810_XXV_SFP",
             "ICE_100G-E810C_QSFP",
             "ICE_25G-E823C_QSFP",
             "I40E_40G-QSFP_B",
@@ -3247,6 +3261,7 @@ class TestGenericFlowApi(TestCase):
                 "IXGBE_10G-X550EM_X_10G_T",
                 "IXGBE_10G-X550T",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E823C_QSFP",
                 "I40E_10G-SFP_X710",
@@ -3267,6 +3282,7 @@ class TestGenericFlowApi(TestCase):
             "I40E_25G-25G_SFP28",
             "I40E_40G-QSFP_A",
             "ICE_25G-E810C_SFP",
+            "ICE_25G-E810_XXV_SFP",
             "ICE_100G-E810C_QSFP",
             "ICE_25G-E823C_QSFP",
             "I40E_40G-QSFP_B",
@@ -4150,6 +4166,7 @@ class TestGenericFlowApi(TestCase):
                 "IGC-I225_LM",
                 "IGC-I226_LM",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E823C_QSFP",
             ],
@@ -4165,6 +4182,7 @@ class TestGenericFlowApi(TestCase):
             "I40E_10G-SFP_X722",
             "I40E_10G-10G_BASE_T_X722",
             "ICE_25G-E810C_SFP",
+            "ICE_25G-E810_XXV_SFP",
             "ICE_100G-E810C_QSFP",
             "ICE_25G-E823C_QSFP",
         ]:
@@ -4746,6 +4764,7 @@ class TestGenericFlowApi(TestCase):
                 "I40E_10G-10G_BASE_T_X722",
                 "I40E_10G-SFP_X722",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E823C_QSFP",
             ],
@@ -4771,6 +4790,7 @@ class TestGenericFlowApi(TestCase):
             "I40E_10G-10G_BASE_T_X722",
             "I40E_10G-SFP_X722",
             "ICE_25G-E810C_SFP",
+            "ICE_25G-E810_XXV_SFP",
             "ICE_100G-E810C_QSFP",
             "ICE_25G-E823C_QSFP",
         ]:
@@ -4817,6 +4837,7 @@ class TestGenericFlowApi(TestCase):
                 "IXGBE_10G-X550EM_X_10G_T",
                 "IXGBE_10G-X550T",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E823C_QSFP",
                 "IGC-I225_LM",
@@ -5018,6 +5039,7 @@ class TestGenericFlowApi(TestCase):
                 "I40E_25G-25G_SFP28",
                 "I40E_40G-QSFP_A",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E823C_QSFP",
                 "I40E_40G-QSFP_B",
@@ -5285,6 +5307,7 @@ class TestGenericFlowApi(TestCase):
                 "I40E_25G-25G_SFP28",
                 "I40E_40G-QSFP_A",
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E823C_QSFP",
                 "I40E_40G-QSFP_B",
diff --git a/tests/TestSuite_ice_buffer_split.py b/tests/TestSuite_ice_buffer_split.py
index d8057cf1..0b646081 100644
--- a/tests/TestSuite_ice_buffer_split.py
+++ b/tests/TestSuite_ice_buffer_split.py
@@ -522,7 +522,12 @@ class TestICEBufferSplit(TestCase):
         """
         self.verify(
             self.nic
-            in ["ICE_25G-E810C_SFP", "ICE_100G-E810C_QSFP", "ICE_25G-E823C_QSFP"],
+            in [
+                "ICE_25G-E810C_SFP",
+                "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
+                "ICE_25G-E810_XXV_SFP",
+            ],
             "%s nic not support timestamp" % self.nic,
         )
         self.dut_ports = self.dut.get_ports(self.nic)
diff --git a/tests/TestSuite_ice_rx_timestamp.py b/tests/TestSuite_ice_rx_timestamp.py
index ea106cda..b01325d1 100644
--- a/tests/TestSuite_ice_rx_timestamp.py
+++ b/tests/TestSuite_ice_rx_timestamp.py
@@ -75,7 +75,12 @@ class TestICERxTimestamp(TestCase):
         """
         self.verify(
             self.nic
-            in ["ICE_25G-E810C_SFP", "ICE_100G-E810C_QSFP", "ICE_25G-E823C_QSFP"],
+            in [
+                "ICE_25G-E810C_SFP",
+                "ICE_100G-E810C_QSFP",
+                "ICE_25G-E823C_QSFP",
+                "ICE_25G-E810_XXV_SFP",
+            ],
             "%s nic not support timestamp" % self.nic,
         )
         self.dut_ports = self.dut.get_ports(self.nic)
diff --git a/tests/TestSuite_link_status_interrupt.py b/tests/TestSuite_link_status_interrupt.py
index 9f9a3f24..bbffe676 100644
--- a/tests/TestSuite_link_status_interrupt.py
+++ b/tests/TestSuite_link_status_interrupt.py
@@ -40,6 +40,7 @@ class TestLinkStatusInterrupt(TestCase):
         if self.nic in [
             "ICE_25G-E810C_SFP",
             "ICE_100G-E810C_QSFP",
+            "ICE_25G-E810_XXV_SFP",
             "I40E_10G-SFP_X710",
             "I40E_40G-QSFP_A",
             "I40E_40G-QSFP_B",
diff --git a/tests/TestSuite_pmdrssreta.py b/tests/TestSuite_pmdrssreta.py
index 503d87bc..cb3cec1a 100644
--- a/tests/TestSuite_pmdrssreta.py
+++ b/tests/TestSuite_pmdrssreta.py
@@ -293,6 +293,7 @@ class TestPmdRSSReta(TestCase):
             "ICE_25G-E810C_SFP": 52,
             "ICE_25G-E823C_QSFP": 52,
             "ICE_100G-E810C_QSFP": 52,
+            "ICE_25G-E810_XXV_SFP": 52,
             "I40E_10G-SFP_X710": 52,
             "I40E_40G-QSFP_A": 52,
             "I40E_40G-QSFP_B": 52,
diff --git a/tests/TestSuite_rxtx_offload.py b/tests/TestSuite_rxtx_offload.py
index 7b4b9655..a34c6a17 100644
--- a/tests/TestSuite_rxtx_offload.py
+++ b/tests/TestSuite_rxtx_offload.py
@@ -607,6 +607,7 @@ class TestRxTxOffload(TestCase):
             "ICE_100G-E810C_QSFP",
             "ICE_25G-E810C_SFP",
             "ICE_25G-E823C_QSFP",
+            "ICE_25G-E810_XXV_SFP",
         ]:
             self.dut.send_expect("port stop 0", "testpmd> ")
             self.dut.send_expect(
@@ -661,6 +662,7 @@ class TestRxTxOffload(TestCase):
             "I40E_10G-10G_BASE_T_BC",
             "ICE_100G-E810C_QSFP",
             "ICE_25G-E810C_SFP",
+            "ICE_25G-E810_XXV_SFP",
         ]:
             self.dut.send_expect("port stop 0", "testpmd> ")
             self.dut.send_expect(
@@ -799,6 +801,7 @@ class TestRxTxOffload(TestCase):
             "I40E_10G-10G_BASE_T_BC",
             "ICE_100G-E810C_QSFP",
             "ICE_25G-E810C_SFP",
+            "ICE_25G-E810_XXV_SFP",
         ]:
             self.dut.send_expect("port stop 0", "testpmd> ")
             self.dut.send_expect(
@@ -836,6 +839,7 @@ class TestRxTxOffload(TestCase):
                 "ICE_100G-E810C_QSFP",
                 "ICE_25G-E810C_SFP",
                 "ICE_25G-E823C_QSFP",
+                "ICE_25G-E810_XXV_SFP",
             ],
             "%s nic not support rx offload setting by queue." % self.nic,
         )
diff --git a/tests/TestSuite_scatter.py b/tests/TestSuite_scatter.py
index 171829ef..50346fe7 100644
--- a/tests/TestSuite_scatter.py
+++ b/tests/TestSuite_scatter.py
@@ -56,6 +56,7 @@ class TestScatter(TestCase):
             "IXGBE_10G-X550EM_X_10G_T",
             "I40E_10G-10G_BASE_T_BC",
             "ICE_25G-E810C_SFP",
+            "ICE_25G-E810_XXV_SFP",
             "ICE_100G-E810C_QSFP",
             "ICE_25G-E823C_QSFP",
         ]:
diff --git a/tests/TestSuite_uni_pkt.py b/tests/TestSuite_uni_pkt.py
index 72bfe6dd..b3100c7d 100644
--- a/tests/TestSuite_uni_pkt.py
+++ b/tests/TestSuite_uni_pkt.py
@@ -283,6 +283,7 @@ class TestUniPkt(TestCase):
                 "ICE_25G-E810C_SFP",
                 "ICE_25G-E823C_QSFP",
                 "ICE_100G-E810C_QSFP",
+                "ICE_25G-E810_XXV_SFP",
                 "IXGBE_10G-82599_SFP",
                 "I40E_10G-SFP_X710",
                 "I40E_40G-QSFP_A",
diff --git a/tests/TestSuite_userspace_ethtool.py b/tests/TestSuite_userspace_ethtool.py
index b62e732f..ad0ce641 100644
--- a/tests/TestSuite_userspace_ethtool.py
+++ b/tests/TestSuite_userspace_ethtool.py
@@ -545,6 +545,7 @@ class TestUserspaceEthtool(TestCase):
             # so skip this step of verify status
             if self.nic not in [
                 "ICE_25G-E810C_SFP",
+                "ICE_25G-E810_XXV_SFP",
                 "IXGBE_10G-X550T",
                 "ICE_100G-E810C_QSFP",
             ]:
@@ -594,6 +595,7 @@ class TestUserspaceEthtool(TestCase):
             "ICE_25G-E810C_SFP",
             "ICE_100G-E810C_QSFP",
             "ICE_25G-E823C_QSFP",
+            "ICE_25G-E810_XXV_SFP",
         ]:
             offset = 8
         for index in range(len(self.ports)):
@@ -609,6 +611,7 @@ class TestUserspaceEthtool(TestCase):
                     "ICE_25G-E810C_SFP",
                     "ICE_100G-E810C_QSFP",
                     "ICE_25G-E823C_QSFP",
+                    "ICE_25G-E810_XXV_SFP",
                 ]:
                     self.dut.send_expect("stop %s" % index, "EthApp>")
                 # The mtu threshold is 2022,When it is greater than 2022, the open/stop port is required.
@@ -629,6 +632,7 @@ class TestUserspaceEthtool(TestCase):
                     "ICE_25G-E810C_SFP",
                     "ICE_100G-E810C_QSFP",
                     "ICE_25G-E823C_QSFP",
+                    "ICE_25G-E810_XXV_SFP",
                 ]:
                     self.dut.send_expect("open %s" % index, "EthApp>")
 
diff --git a/tests/TestSuite_vxlan.py b/tests/TestSuite_vxlan.py
index bfdf5b90..9989f515 100644
--- a/tests/TestSuite_vxlan.py
+++ b/tests/TestSuite_vxlan.py
@@ -280,6 +280,7 @@ class TestVxlan(TestCase):
             "ICE_25G-E810C_SFP",
             "ICE_100G-E810C_QSFP",
             "ICE_25G-E823C_QSFP",
+            "ICE_25G-E810_XXV_SFP",
         ]:
             print("Intel® Ethernet 700 Series support default none VECTOR")
         else: